/*
 * FlashActors.c
 *
 * Created: 11.12.2012 19:01:36
 *  Author: Vladimir
 */ 

#include "FlashActors.h"

//   
void RearColorFlash(uint16_t phase, actorCustomVar* CustomVars){
	
	if (phase == 1 || phase % 50 == 0){
		stp16_d LedData = {
			.led2 = 0,
			.led3 = 0,
			.led4 = 0,
			.led5 = 0,
			.led6 = 0,
			.led7 = 1,
			.led8 = 0,
			.led9 = 0,
			.led10 = 0,
			.led11 = 0,
			.led12 = 0,
			.led13 = 1,
			.dimmer = 255
		};
		stp16_sendData(&LedData);
		
	} else if (phase % 10 == 0){
		stp16_allLedsOff();
	}
	
}


//    
#define DOUBLEREARFLASH_STEP_PHASE 2
void DoubleRearFlash(uint16_t phase, actorCustomVar* CustomVars){

	if (phase % DOUBLEREARFLASH_STEP_PHASE == 0) return;
	
	stp16_d LedData = {
		.led2 = 0,
		.led3 = 0,
		.led4 = 0,
		.led5 = 0,
		.led6 = 0,
		.led7 = 0,
		.led8 = 0,
		.led9 = 0,
		.led10 = 0,
		.led11 = 0,
		.led12 = 0,
		.led13 = 0,
		.dimmer = 255
	};
	
	switch(CustomVars->i8){
		
		case 0: case 2: case 4:
		LedData.led7 = 1;
		LedData.led13 = 1;
		break;
	}
	
	stp16_sendData(&LedData);
	CustomVars->i8++;

	if (CustomVars->i8 > 40) CustomVars->i8 = 0;
}
#undef DOUBLEREARFLASH_STEP_PHASE

//    2- 
void ColorFlashActor(uint16_t phase, actorCustomVar* CustomVars){

	stp16_d LedData = {
		.led2 = 0,
		.led3 = 1,
		.led4 = 0,
		.led5 = 1,
		.led6 = 0,
		.led7 = 1,
		.led8 = 0,
		.led9 = 1,
		.led10 = 0,
		.led11 = 1,
		.led12 = 0,
		.led13 = 1,
		.dimmer = 255
	};

	if (phase % 2 == 0){
		stp16_sendData(&LedData);
		return;
	}

	dimmer_lightOff();
}

//   ,    
void EmergencyFlashActor(uint16_t phase, actorCustomVar* CustomVars){
	
	stp16_d LedData = {
		0,0,0,0,0,0,0,0,0,0,0,0,
		.dimmer = 255
	};

	phase = phase % 40;
	
	extern firmware_propperties_t Config;
	if (Config.isMaster){
		switch (phase){
			case 0: case 2: case 4: case 6: case 8:
			LedData.led3 = 1;
			LedData.led5 = 1;
			LedData.led7 = 1;
			LedData.led9 = 1;
			LedData.led11 = 1;
			LedData.led13 = 1;
			break;
		}
	} else {
		switch (phase){
			case 10: case 12: case 14: case 16: case 18:
			LedData.led3 = 1;
			LedData.led5 = 1;
			LedData.led7 = 1;
			LedData.led9 = 1;
			LedData.led11 = 1;
			LedData.led13 = 1;
			break;
		}
	}

	stp16_sendData(&LedData);
}

//    
#define SWAPCOLOR_SPEED 5
void SwapColorActor(uint16_t phase, actorCustomVar* CustomVars){

	if (phase % SWAPCOLOR_SPEED != 0) return;
	
	stp16_d LedData = {
		.led2 = 1,
		.led3 = 0,
		.led4 = 1,
		.led5 = 0,
		.led6 = 1,
		.led7 = 0,
		.led8 = 1,
		.led9 = 0,
		.led10 = 1,
		.led11 = 0,
		.led12 = 1,
		.led13 = 0,
		.dimmer = 255
	};
	
	CustomVars->ui8 ^= 0xFF;
	if (CustomVars->ui8){
		LedData.led2 = 0;
		LedData.led4 = 0;
		LedData.led6 = 0;
		LedData.led8 = 0;
		LedData.led10 = 0;
		LedData.led12 = 0;
		LedData.led3 = 1;
		LedData.led5 = 1;
		LedData.led7 = 1;
		LedData.led9 = 1;
		LedData.led11 = 1;
		LedData.led13 = 1;
	}
	
	stp16_sendData(&LedData);
}
#undef SWAPCOLOR_SPEED
