/*
 * LinearActors.c
 *
 * Created: 13.12.2012 21:17:54
 *  Author: Vladimir
 */ 

#include "LinearActors.h"


//  
#define ACCLINE_SPEED 4
void AccLineActor(uint16_t phase, actorCustomVar* CustomVars){
	
	if (phase % ACCLINE_SPEED != 0) return;
	
	stp16_d LedData = {
		0,0,0,0,0,0,0,0,0,0,0,0,
		.dimmer = 255
	};
	
	switch (CustomVars->i8){
		
		case 0:
		LedData.led2 = 1;
		LedData.led8 = 1;
		break;

		case 1:
		LedData.led4 = 1;
		LedData.led10 = 1;
		break;

		case 2:
		LedData.led6 = 1;
		LedData.led12 = 1;
		break;
		
	}

	CustomVars->i8++;
	if (CustomVars->i8 > 6) CustomVars->i8 = 0;
	stp16_sendData(&LedData);
}
#undef ACCLINE_SPEED


//   
#define ACCCOLORLINE_SPEED 3
void AccColorLineActor(uint16_t phase, actorCustomVar* CustomVars){
	
	if (phase % ACCCOLORLINE_SPEED != 0) return;
	
	stp16_d LedData = {
		0,0,0,0,0,0,0,0,0,0,0,0,
		.dimmer = 255
	};
	
	switch (CustomVars->i8){
		
		case 0:
		LedData.led3 = 1;
		LedData.led9 = 1;
		break;

		case 1:
		LedData.led5 = 1;
		LedData.led11 = 1;
		break;

		case 2:
		LedData.led7 = 1;
		LedData.led13 = 1;
		break;
		
	}

	CustomVars->i8++;
	if (CustomVars->i8 > 5) CustomVars->i8 = 0;
	stp16_sendData(&LedData);
}
#undef ACCCOLORLINE_SPEED


//    
#define ACCFULLLINE_SPEED 4
void AccFullLineActor(uint16_t phase, actorCustomVar* CustomVars){
	
	if (phase % ACCFULLLINE_SPEED != 0) return;
	
	stp16_d LedData = {
		0,0,0,0,0,0,0,0,0,0,0,0,
		.dimmer = 255
	};
	
	extern firmware_propperties_t Config;
	if (Config.isMaster){
		switch (CustomVars->i8){
			
			case 0:
			LedData.led2 = 1;
			LedData.led8 = 1;
			break;

			case 1:
			LedData.led4 = 1;
			LedData.led10 = 1;
			break;

			case 2:
			LedData.led6 = 1;
			LedData.led12 = 1;
			break;

			case 6:
			LedData.led3 = 1;
			LedData.led9 = 1;
			break;

			case 7:
			LedData.led5 = 1;
			LedData.led11 = 1;
			break;

			case 8:
			LedData.led7 = 1;
			LedData.led13 = 1;
			break;
		}
	} else {
		switch (CustomVars->i8){
			
			case 3:
			LedData.led2 = 1;
			LedData.led8 = 1;
			break;

			case 4:
			LedData.led4 = 1;
			LedData.led10 = 1;
			break;

			case 5:
			LedData.led6 = 1;
			LedData.led12 = 1;
			break;

			case 9:
			LedData.led3 = 1;
			LedData.led9 = 1;
			break;

			case 10:
			LedData.led5 = 1;
			LedData.led11 = 1;
			break;

			case 11:
			LedData.led7 = 1;
			LedData.led13 = 1;
			break;
		}
	}

	CustomVars->i8++;
	if (CustomVars->i8 > 11) CustomVars->i8 = 0;
	stp16_sendData(&LedData);
}
#undef ACCFULLLINE_SPEED
