/*
 * RotaryActors.c
 *
 * Created: 11.12.2012 19:42:07
 *  Author: Vladimir
 */ 

#include "RotaryActors.h"

//    
#define PHASE_STROBE_INTERVAL 8
void Rotate1pActor(uint16_t phase, actorCustomVar* CustomVars){
	
	if (phase % PHASE_STROBE_INTERVAL != 0) return;
	
	stp16_d LedData = {
		0,0,0,0,0,0,0,0,0,0,0,0,
		.dimmer = 255
	};
	
	switch (CustomVars->i8){
		
		case 0:
		LedData.led2 = 1;
		LedData.led12 = 1;
		CustomVars->i8 = 1;
		break;
		
		case 1:
		LedData.led4 = 1;
		LedData.led10 = 1;
		CustomVars->i8 = 2;
		break;
		
		case 2:
		LedData.led6 = 1;
		LedData.led8 = 1;
		CustomVars->i8 = 0;
		break;
		
	}

	stp16_sendData(&LedData);
}
#undef PHASE_STROBE_INTERVAL

//    
#define ROTATE2P_SPEED 4
void Rotate2pActor(uint16_t phase, actorCustomVar* CustomVars){
	
	if (phase % ROTATE2P_SPEED != 0) return;
	
	stp16_d LedData = {
		0,0,0,0,0,0,0,0,0,0,0,0,
		.dimmer = 255
	};
	
	switch (CustomVars->i8){
		
		case 0:
		LedData.led2 = 1;
		LedData.led12 = 1;
		break;

		case 1:
		LedData.led2 = 1;
		LedData.led12 = 1;
		LedData.led4 = 1;
		LedData.led10 = 1;
		LedData.dimmer = 70;
		break;

		case 2:
		LedData.led4 = 1;
		LedData.led10 = 1;
		break;

		case 3:
		LedData.led4 = 1;
		LedData.led10 = 1;
		LedData.led6 = 1;
		LedData.led8 = 1;
		LedData.dimmer = 70;
		break;

		case 4:
		LedData.led6 = 1;
		LedData.led8 = 1;
		break;

		case 5:
		LedData.led6 = 1;
		LedData.led8 = 1;
		LedData.led2 = 1;
		LedData.led12 = 1;
		LedData.dimmer = 70;
		CustomVars->i8 = -1;
		break;
		
	}

	CustomVars->i8++;
	stp16_sendData(&LedData);
}
#undef ROTATE2P_SPEED

//     
#define EMERGENCY_PHASE_STEP 5
void EmergencyActor(uint16_t phase, actorCustomVar* CustomVars){
	
	if (phase % EMERGENCY_PHASE_STEP != 0) return;
	
	stp16_d LedData = {
		0,0,0,0,0,0,0,0,0,0,0,0,
		.dimmer = 255
	};
	
	extern firmware_propperties_t Config;
	if (Config.isMaster){
		switch (CustomVars->i8){
			
			case 0:
			LedData.led3 = 1;
			LedData.led13 = 1;
			break;
			
			case 1:
			LedData.led5 = 1;
			LedData.led11 = 1;
			break;
			
			case 2:
			LedData.led7 = 1;
			LedData.led9 = 1;
			CustomVars->i8 = -1;
			break;
			
		}
	} else {
		switch (CustomVars->i8){
			
			case 0:
			LedData.led5 = 1;
			LedData.led11 = 1;
			break;
			
			case 1:
			LedData.led7 = 1;
			LedData.led9 = 1;
			break;
			
			case 2:
			LedData.led3 = 1;
			LedData.led13 = 1;
			CustomVars->i8 = -1;
			break;
			
		}
	}

	CustomVars->i8++;

	stp16_sendData(&LedData);
}
#undef EMERGENCY_PHASE_STEP


//     
#define EMERGENCYSLOW_PHASE_STEP 3
void EmergencySlowActor(uint16_t phase, actorCustomVar* CustomVars){
	
	if (phase % EMERGENCYSLOW_PHASE_STEP != 0) return;
	
	stp16_d LedData = {
		0,0,0,0,0,0,0,0,0,0,0,0,
		.dimmer = 255
	};
	
	extern firmware_propperties_t Config;
	if (Config.isMaster){
		switch (CustomVars->i8){
			
			case 0:
			LedData.led3 = 1;
			LedData.led13 = 1;
			break;

			case 1:
			LedData.led3 = 1;
			LedData.led13 = 1;
			LedData.led5 = 1;
			LedData.led11 = 1;
			LedData.dimmer = 70;
			break;
			
			case 2:
			LedData.led5 = 1;
			LedData.led11 = 1;
			break;

			case 3:
			LedData.led5 = 1;
			LedData.led11 = 1;
			LedData.led7 = 1;
			LedData.led9 = 1;
			LedData.dimmer = 70;
			break;

			case 4:
			LedData.led7 = 1;
			LedData.led9 = 1;
			break;

			case 5:
			LedData.led7 = 1;
			LedData.led9 = 1;
			LedData.led3 = 1;
			LedData.led13 = 1;
			LedData.dimmer = 70;
			CustomVars->i8 = -1;
			break;
			
		}
	} else {
		switch (CustomVars->i8){
			
			case 0:
			LedData.led5 = 1;
			LedData.led11 = 1;
			break;

			case 1:
			LedData.led5 = 1;
			LedData.led11 = 1;
			LedData.led7 = 1;
			LedData.led9 = 1;
			LedData.dimmer = 70;
			break;
			
			case 2:
			LedData.led7 = 1;
			LedData.led9 = 1;
			break;

			case 3:
			LedData.led7 = 1;
			LedData.led9 = 1;
			LedData.led3 = 1;
			LedData.led13 = 1;
			LedData.dimmer = 70;
			break;

			case 4:
			LedData.led3 = 1;
			LedData.led13 = 1;
			break;

			case 5:
			LedData.led3 = 1;
			LedData.led13 = 1;
			LedData.led5 = 1;
			LedData.led11 = 1;
			LedData.dimmer = 70;
			CustomVars->i8 = -1;
			break;
			
		}
	}

	CustomVars->i8++;

	stp16_sendData(&LedData);
}
#undef EMERGENCYSLOW_PHASE_STEP


//      ,  
#define ROTATESPOTLIGHT_SPEED 2
void RotateSpotlightActor(uint16_t phase, actorCustomVar* CustomVars){
	
	if (phase % ROTATESPOTLIGHT_SPEED != 0) return;
	
	stp16_d LedData = {
		0,0,0,0,0,0,0,0,0,0,0,0,
		.dimmer = 255
	};
	
	extern firmware_propperties_t Config;
	if (Config.isMaster){
		switch (CustomVars->i8){
			
			case 0:
			LedData.led2 = 1;
			break;

			case 1:
			LedData.led4 = 1;
			break;

			case 2:
			LedData.led6 = 1;
			break;

		}
	} else {
		switch (CustomVars->i8){
			
			case 3:
			LedData.led12 = 1;
			break;
			
			case 4:
			LedData.led10 = 1;
			break;
			
			case 5:
			LedData.led8 = 1;
			break;
			
		}
	}

	CustomVars->i8++;
	if (CustomVars->i8 >= 6) CustomVars->i8 = 0;

	stp16_sendData(&LedData);
}
#undef ROTATESPOTLIGHT_SPEED

//     1   
void RotatePointActor(uint16_t phase, actorCustomVar* CustomVars){
	
	stp16_d LedData = {
		0,0,0,0,0,0,0,0,0,0,0,0,
		.dimmer = 255
	};

	phase = phase % 12;
	
	switch (phase){
		
		case 0:
		LedData.led8 = 1;
		break;

		case 1:
		LedData.led8 = 1;
		LedData.led10= 1;
		LedData.dimmer = 70;
		break;
		
		case 2:
		LedData.led10 = 1;
		break;

		case 3:
		LedData.led10 = 1;
		LedData.led12 = 1;
		LedData.dimmer = 70;
		break;

		case 4:
		LedData.led12 = 1;
		break;

		case 5:
		LedData.led12 = 1;
		LedData.led6 = 1;
		LedData.dimmer = 70;
		break;

		case 6:
		LedData.led6 = 1;
		break;

		case 7:
		LedData.led6 = 1;
		LedData.led4 = 1;
		LedData.dimmer = 70;
		break;

		case 8:
		LedData.led4 = 1;
		break;

		case 9:
		LedData.led4 = 1;
		LedData.led2 = 1;
		LedData.dimmer = 70;
		break;

		case 10:
		LedData.led2 = 1;
		break;

		case 11:
		LedData.led2 = 1;
		LedData.led8 = 1;
		LedData.dimmer = 70;
		break;

		
	}

	stp16_sendData(&LedData);
}

//     1   
void RotateColorPointActor(uint16_t phase, actorCustomVar* CustomVars){
	
	stp16_d LedData = {
		0,0,0,0,0,0,0,0,0,0,0,0,
		.dimmer = 255
	};

	extern firmware_propperties_t Config;
	if (!Config.isMaster) phase+=5;
	phase = phase % 12;

	switch (phase){
		
		case 0:
		LedData.led9 = 1;
		break;

		case 1:
		LedData.led9 = 1;
		LedData.led11= 1;
		LedData.dimmer = 70;
		break;
		
		case 2:
		LedData.led11 = 1;
		break;

		case 3:
		LedData.led11 = 1;
		LedData.led13 = 1;
		LedData.dimmer = 70;
		break;

		case 4:
		LedData.led13 = 1;
		break;

		case 5:
		LedData.led13 = 1;
		LedData.led7 = 1;
		LedData.dimmer = 70;
		break;

		case 6:
		LedData.led7 = 1;
		break;

		case 7:
		LedData.led7 = 1;
		LedData.led5 = 1;
		LedData.dimmer = 70;
		break;

		case 8:
		LedData.led5 = 1;
		break;

		case 9:
		LedData.led5 = 1;
		LedData.led3 = 1;
		LedData.dimmer = 70;
		break;

		case 10:
		LedData.led3 = 1;
		break;

		case 11:
		LedData.led3 = 1;
		LedData.led9 = 1;
		LedData.dimmer = 70;
		break;
	}

	stp16_sendData(&LedData);
}


//   
#define ROTATEPOINT_SPEED 7
void RockerActor(uint16_t phase, actorCustomVar* CustomVars){
	
	if (phase % ROTATEPOINT_SPEED != 0) return;
	
	stp16_d LedData = {
		0,0,0,0,0,0,0,0,0,0,0,0,
		.dimmer = 255
	};
	
	switch (CustomVars->i8){
		
		case 0:
		LedData.led6 = 1;
		LedData.led8 = 1;
		break;
		
		case 1:
		LedData.led4 = 1;
		LedData.led10 = 1;
		break;
		
		case 2:
		LedData.led2 = 1;
		LedData.led12 = 1;
		break;
		
		case 3:
		LedData.led4 = 1;
		LedData.led10 = 1;
		CustomVars->i8 = -1;
		break;
		
	}

	CustomVars->i8++;

	stp16_sendData(&LedData);
}
#undef ROTATEPOINT_SPEED

//   
#define ROTATECOLORPOINT_SPEED 2
void RockerColorActor(uint16_t phase, actorCustomVar* CustomVars){
	
	if (phase % ROTATECOLORPOINT_SPEED != 0) return;
	
	stp16_d LedData = {
		0,0,0,0,0,0,0,0,0,0,0,0,
		.dimmer = 255
	};
	
	switch (CustomVars->i8){
		
		case 0:
		LedData.led3 = 1;
		LedData.led13 = 1;
		break;
		
		case 1:
		LedData.led5 = 1;
		LedData.led11 = 1;
		break;
		
		case 2:
		LedData.led7 = 1;
		LedData.led9 = 1;
		break;
		
		case 3:
		LedData.led5 = 1;
		LedData.led11 = 1;
		CustomVars->i8 = -1;
		break;
		
	}

	CustomVars->i8++;

	stp16_sendData(&LedData);
}
#undef ROTATECOLORPOINT_SPEED
